//> ===>
//> Title: Saving Variables
//> Author: Truce
//> ===>

%error=forceRequiredAddOn("Event_Variables");
if(%error==$Error::AddOn_Disabled) {
	error("Event_SavingVariables - Required Add-On Event_Variables not enabled.");
	return;
}
else if(%error==$Error::AddOn_NotFound) {
	error("Event_SavingVariables - Required Add-On Event_Variables not found.");
	return;
}
registerOutputEvent(GameConnection,SaveVariable,"list Player 0 Client 1\tstring 32 100",1);
registerOutputEvent(GameConnection,LoadVariable,"list Player 0 Client 1\tstring 32 100",1);
$VSF::Path="config/server/savedVars.txt";
function GameConnection::saveVariable(%t,%target,%var,%cl) {
	switch(%target) {
		case 0:
			%target=%cl.player;
			%type="Player";
		case 1:
			%target=%cl;
			%type="Client";
	}
	%BLID=%cl.bl_id;
	%value=%target.var[%var];
	%line=VarReturnLine(%BLID,%type,%var);
	if(%line==0)
		$VSF::Line[$VSF::Count++]=%BLID TAB %type TAB %var TAB %value;
	else
		$VSF::Line[%line]=%BLID TAB %type TAB %var TAB %value;
	%file=new FileObject();
	%file.openForWrite($VSF::Path);
	%file.writeLine("[VARIABLE SAVE FILE]");
	for(%i=1;%i<=$VSF::Count;%i++) {
		%file.writeLine($VSF::Line[%i]);
	}
	%file.close();
	%file.delete();
}
function GameConnection::loadVariable(%t,%target,%var,%cl) {
	switch(%target) {
		case 0:
			%target=%cl.player;
			%type="Player";
		case 1:
			%target=%cl;
			%type="Client";
	}
	%BLID=%cl.bl_id;
	%value=%target.var[%var];
	%line=VarReturnLine(%BLID,%type,%var);
	if(%line==0)
		return;
	%target.var[%var]=getField($VSF::Line[%line],3);
}
function VarReturnLine(%BLID,%type,%var) {
	VarUpdateFile();
	if($VSF::count==0)
		return 0;
	for(%i=1;%i<=$VSF::Count;%i++) {
		%line=$VSF::Line[%i];
		if(getField(%line,0)==%BLID&&getField(%line,1)$=%type&&getField(%line,2)$=%var)
			return %i;
	}
	return 0;
}
function VarUpdateFile() {
	$VSF::Count=0;
	%file=new FileObject();
	if(!isFile($VSF::Path)) {
		%file.openForWrite($VSF::Path);
		%file.writeLine("[VARIABLE SAVE FILE]");
		%file.close();
		%file.delete();
		return;
	}
	%file.openForRead($VSF::Path);
	%file.readLine();
	while(!%file.isEOF()) {
		$VSF::Line[$VSF::Count++]=%file.readLine();
	}
	%file.close();
	%file.delete();
}